%global __strip %{mingw_strip}
%global __objdump %{mingw_objdump}
%global _use_internal_dependency_generator 0
%global __find_requires %{mingw_findrequires}
%global __find_provides %{mingw_findprovides}
%define __debug_install_post %{mingw_debug_install_post}

%global mingw_pkg_name gstreamer
%global mingw_build_win32 1
%global mingw_build_win64 1

%define         gstreamer       gstreamer
%define         majorminor      0.10

Name:           mingw-gstreamer
Version:        0.10.33
Release:        1%{?dist}
Summary:        Cross compiled GStreamer media framework

Group:          Applications/Multimedia
License:        LGPLv2+
URL:            http://gstreamer.freedesktop.org/
Source:         http://gstreamer.freedesktop.org/src/gstreamer/gstreamer-%{version}.tar.bz2
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildArch:      noarch

BuildRequires:  mingw-filesystem >= 65
BuildRequires:  mingw32-gcc
BuildRequires:  mingw32-binutils
BuildRequires:  mingw32-glib2
BuildRequires:  mingw32-libxml2
BuildRequires:  mingw32-gettext
BuildRequires:  mingw64-gcc
BuildRequires:  mingw64-binutils
BuildRequires:  mingw64-glib2
BuildRequires:  mingw64-libxml2
BuildRequires:  mingw64-gettext
BuildRequires:  bison
BuildRequires:  flex
BuildRequires:  m4
# native lib needed for glib-mkenums and glib-genmarshal
BuildRequires:  glib2-devel
BuildRequires:  pkgconfig
# We need to use the system libtool or else we end up with RPATHs
BuildRequires:  libtool

%{?mingw_default_requires}
%{?mingw_debug_package}

%description
GStreamer is a streaming media framework, based on graphs of filters which
operate on media data. Applications using this library can do anything
from real-time sound processing to playing videos, and just about anything
else media-related.  Its plugin-based architecture means that new data
types or processing capabilities can be added simply by installing new 
plugins.

# Mingw32
%package -n mingw32-%{mingw_pkg_name}
Summary:        %{summary}
Requires:       mingw32-%{mingw_pkg_name}-tools >= %{version}

%description -n mingw32-%{mingw_pkg_name}
Cross compiled GStreamer media framework.

%package -n mingw32-%{mingw_pkg_name}-static
Summary:        Static libraries for the GStreamer media framework
Group:          Development/Libraries
Requires:       mingw32-%{mingw_pkg_name} = %{version}-%{release}

%description -n mingw32-%{mingw_pkg_name}-static
Static version of the cross compiled GStreamer media framework.

%package -n mingw32-%{mingw_pkg_name}-tools
Summary:        Common tools and files for GStreamer streaming media framework
Group:          Applications/Multimedia

%description -n mingw32-%{mingw_pkg_name}-tools
Wrapper scripts for the command-line tools of GStreamer.


# Mingw64
%package -n mingw64-%{mingw_pkg_name}
Summary:        %{summary}
Requires:       mingw64-%{mingw_pkg_name}-tools >= %{version}

%description -n mingw64-%{mingw_pkg_name}
Cross compiled GStreamer media framework.

%package -n mingw64-%{mingw_pkg_name}-static
Summary:        Static libraries for the GStreamer media framework
Group:          Development/Libraries
Requires:       mingw64-%{mingw_pkg_name} = %{version}-%{release}

%description -n mingw64-%{mingw_pkg_name}-static
Static version of the cross compiled GStreamer media framework.

%package -n mingw64-%{mingw_pkg_name}-tools
Summary:        Common tools and files for GStreamer streaming media framework
Group:          Applications/Multimedia

%description -n mingw64-%{mingw_pkg_name}-tools
Wrapper scripts for the command-line tools of GStreamer.


%prep
%setup -q -n gstreamer-%{version}

%build
%mingw_configure "--with-package-name='Fedora Mingw gstreamer package'" "--with-package-origin='http://download.fedora.redhat.com/fedora'" "--disable-gtk-doc" "--enable-debug" "--disable-tests" "--disable-examples"

%mingw_make %{?_smp_mflags}

%install  
rm -rf $RPM_BUILD_ROOT
%mingw_make_install DESTDIR=$RPM_BUILD_ROOT

# Remove manpages.
rm -rf $RPM_BUILD_ROOT%{mingw32_mandir} $RPM_BUILD_ROOT%{mingw64_mandir}
# Remove gtk documentation.
rm -rf $RPM_BUILD_ROOT%{mingw32_datadir}/gtk-doc $RPM_BUILD_ROOT%{mingw64_datadir}/gtk-doc

%mingw_find_lang %{name} --all-name

%clean
rm -rf $RPM_BUILD_ROOT

# Mingw32
%files -n mingw32-%{mingw_pkg_name} -f mingw32-%{name}.lang
%defattr(-, root, root, -)
%doc COPYING
%{mingw32_bindir}/libgstreamer-%{majorminor}-0.dll
%{mingw32_bindir}/libgstbase-%{majorminor}-0.dll
%{mingw32_bindir}/libgstcontroller-%{majorminor}-0.dll
%{mingw32_bindir}/libgstdataprotocol-%{majorminor}-0.dll
%{mingw32_bindir}/libgstnet-%{majorminor}-0.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/*.dll.a
%{mingw32_libdir}/*.dll.a

%dir %{mingw32_libdir}/gstreamer-%{majorminor}
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstcoreelements.dll
%{mingw32_libdir}/gstreamer-%{majorminor}/libgstcoreindexers.dll

%dir %{mingw32_libexecdir}/gstreamer-%{majorminor}
%{mingw32_libexecdir}/gstreamer-%{majorminor}/gst-plugin-scanner.exe

%{mingw32_bindir}/gst-feedback-%{majorminor}
%{mingw32_bindir}/gst-inspect-%{majorminor}.exe
%{mingw32_bindir}/gst-launch-%{majorminor}.exe
%{mingw32_bindir}/gst-typefind-%{majorminor}.exe
%{mingw32_bindir}/gst-xmlinspect-%{majorminor}.exe
%{mingw32_bindir}/gst-xmllaunch-%{majorminor}.exe

#%files devel
%dir %{mingw32_includedir}/gstreamer-%{majorminor}
%dir %{mingw32_includedir}/gstreamer-%{majorminor}/gst
%{mingw32_includedir}/gstreamer-%{majorminor}/gst/*.h
%{mingw32_libdir}/gstreamer-%{majorminor}/*.la
%{mingw32_libdir}/*.la

%{mingw32_includedir}/gstreamer-%{majorminor}/gst/base
%{mingw32_includedir}/gstreamer-%{majorminor}/gst/controller
%{mingw32_includedir}/gstreamer-%{majorminor}/gst/dataprotocol
%{mingw32_includedir}/gstreamer-%{majorminor}/gst/net

%{mingw32_datadir}/aclocal/gst-element-check-%{majorminor}.m4
%{mingw32_libdir}/pkgconfig/gstreamer-%{majorminor}.pc
%{mingw32_libdir}/pkgconfig/gstreamer-base-%{majorminor}.pc
%{mingw32_libdir}/pkgconfig/gstreamer-controller-%{majorminor}.pc
%{mingw32_libdir}/pkgconfig/gstreamer-dataprotocol-%{majorminor}.pc
%{mingw32_libdir}/pkgconfig/gstreamer-net-%{majorminor}.pc

%files -n mingw32-%{mingw_pkg_name}-static
%defattr(-, root, root, -)
%{mingw32_libdir}/*%{majorminor}.a

%files -n mingw32-%{mingw_pkg_name}-tools
%defattr(-, root, root, -)
%{mingw32_bindir}/gst-feedback.exe
%{mingw32_bindir}/gst-inspect.exe
%{mingw32_bindir}/gst-launch.exe
%{mingw32_bindir}/gst-typefind.exe
%{mingw32_bindir}/gst-xmlinspect.exe
%{mingw32_bindir}/gst-xmllaunch.exe


# Mingw64
%files -n mingw64-%{mingw_pkg_name} -f mingw64-%{name}.lang
%defattr(-, root, root, -)
%doc COPYING
%{mingw64_bindir}/libgstreamer-%{majorminor}-0.dll
%{mingw64_bindir}/libgstbase-%{majorminor}-0.dll
%{mingw64_bindir}/libgstcontroller-%{majorminor}-0.dll
%{mingw64_bindir}/libgstdataprotocol-%{majorminor}-0.dll
%{mingw64_bindir}/libgstnet-%{majorminor}-0.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/*.dll.a
%{mingw64_libdir}/*.dll.a

%dir %{mingw64_libdir}/gstreamer-%{majorminor}
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstcoreelements.dll
%{mingw64_libdir}/gstreamer-%{majorminor}/libgstcoreindexers.dll

%dir %{mingw64_libexecdir}/gstreamer-%{majorminor}
%{mingw64_libexecdir}/gstreamer-%{majorminor}/gst-plugin-scanner.exe

%{mingw64_bindir}/gst-feedback-%{majorminor}
%{mingw64_bindir}/gst-inspect-%{majorminor}.exe
%{mingw64_bindir}/gst-launch-%{majorminor}.exe
%{mingw64_bindir}/gst-typefind-%{majorminor}.exe
%{mingw64_bindir}/gst-xmlinspect-%{majorminor}.exe
%{mingw64_bindir}/gst-xmllaunch-%{majorminor}.exe

#%files devel
%dir %{mingw64_includedir}/gstreamer-%{majorminor}
%dir %{mingw64_includedir}/gstreamer-%{majorminor}/gst
%{mingw64_includedir}/gstreamer-%{majorminor}/gst/*.h
%{mingw64_libdir}/gstreamer-%{majorminor}/*.la
%{mingw64_libdir}/*.la

%{mingw64_includedir}/gstreamer-%{majorminor}/gst/base
%{mingw64_includedir}/gstreamer-%{majorminor}/gst/controller
%{mingw64_includedir}/gstreamer-%{majorminor}/gst/dataprotocol
%{mingw64_includedir}/gstreamer-%{majorminor}/gst/net

%{mingw64_datadir}/aclocal/gst-element-check-%{majorminor}.m4
%{mingw64_libdir}/pkgconfig/gstreamer-%{majorminor}.pc
%{mingw64_libdir}/pkgconfig/gstreamer-base-%{majorminor}.pc
%{mingw64_libdir}/pkgconfig/gstreamer-controller-%{majorminor}.pc
%{mingw64_libdir}/pkgconfig/gstreamer-dataprotocol-%{majorminor}.pc
%{mingw64_libdir}/pkgconfig/gstreamer-net-%{majorminor}.pc

%files -n mingw64-%{mingw_pkg_name}-static
%defattr(-, root, root, -)
%{mingw64_libdir}/*%{majorminor}.a

%files -n mingw64-%{mingw_pkg_name}-tools
%defattr(-, root, root, -)
%{mingw64_bindir}/gst-feedback.exe
%{mingw64_bindir}/gst-inspect.exe
%{mingw64_bindir}/gst-launch.exe
%{mingw64_bindir}/gst-typefind.exe
%{mingw64_bindir}/gst-xmlinspect.exe
%{mingw64_bindir}/gst-xmllaunch.exe

%changelog
* Fri May 13 2011 - Marc-André Lureau <marcandre.lureau@redhat.com> - 0.10.33-1
- Updated to 0.10.33
- Updated to newer mingw instructions (with mingw64 support)

* Wed Dec 29 2010 - Marc-André Lureau <marcandre.lureau@redhat.com> - 0.10.31-1
- Updated to 0.10.31
- based on initial work by Levente Farkas and Zoltan Seress,
  as well as previous Fedora contributors:
  https://bugzilla.redhat.com/show_bug.cgi?id=mingw32-gstreamer
